diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/test/wifi-mlo-test.cc ns-3.40/src/wifi/test/wifi-mlo-test.cc
--- ns-3.39/src/wifi/test/wifi-mlo-test.cc	2023-07-05 14:23:48.129428400 -0700
+++ ns-3.40/src/wifi/test/wifi-mlo-test.cc	2023-09-27 13:30:37.926839800 -0700
@@ -1771,32 +2370,20 @@
     /**
      * Constructor
      *
+     * \param baseParams common configuration parameters
      * \param muTrafficPattern the pattern of traffic to generate
      * \param useBarAfterMissedBa whether a BAR or Data frames are sent after missed BlockAck
      * \param nMaxInflight the max number of links on which an MPDU can be simultaneously inflight
      *                     (unused if Block Ack agreements are not established)
-     * \param staChannels the strings specifying the operating channels for the STA
-     * \param apChannels the strings specifying the operating channels for the AP
-     * \param fixedPhyBands list of IDs of STA links that cannot switch PHY band
      */
-    MultiLinkMuTxTest(WifiMuTrafficPattern muTrafficPattern,
+    MultiLinkMuTxTest(const BaseParams& baseParams,
+                      WifiMuTrafficPattern muTrafficPattern,
                       WifiUseBarAfterMissedBa useBarAfterMissedBa,
-                      uint8_t nMaxInflight,
-                      const std::vector<std::string>& staChannels,
-                      const std::vector<std::string>& apChannels,
-                      const std::vector<uint8_t>& fixedPhyBands = {});
+                      uint8_t nMaxInflight);
     ~MultiLinkMuTxTest() override = default;
 
   protected:
     /**
-     * Function to trace packets received by the server application
-     * \param nodeId the ID of the node that received the packet
-     * \param p the packet
-     * \param addr the address
-     */
-    void L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr);
-
-    /**
      * Check the content of a received BlockAck frame when the max number of links on which
      * an MPDU can be inflight is one.
      *
@@ -1806,8 +2393,8 @@
      */
     void CheckBlockAck(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, uint8_t linkId);
 
-    void Transmit(uint8_t linkId,
-                  std::string context,
+    void Transmit(Ptr<WifiMac> mac,
+                  uint8_t phyId,
                   WifiConstPsduMap psduMap,
                   WifiTxVector txVector,
                   double txPowerW) override;
@@ -1836,19 +2423,15 @@
     std::size_t m_nPackets;                     ///< number of application packets to generate
     std::size_t m_blockAckCount{0};             ///< transmitted BlockAck counter
     // std::size_t m_blockAckReqCount{0};     ///< transmitted BlockAckReq counter
-    std::array<std::size_t, 3> m_rxPkts{}; ///< number of packets received at application layer
-                                           ///< by each node (AP, STA 0, STA 1)
     std::map<AddrSeqNoPair, std::size_t> m_inflightCount; ///< max number of simultaneous
                                                           ///< transmissions of each data frame
     Ptr<WifiMac> m_sourceMac; ///< MAC of the node sending application packets
 };
 
-MultiLinkMuTxTest::MultiLinkMuTxTest(WifiMuTrafficPattern muTrafficPattern,
+MultiLinkMuTxTest::MultiLinkMuTxTest(const BaseParams& baseParams,
+                                     WifiMuTrafficPattern muTrafficPattern,
                                      WifiUseBarAfterMissedBa useBarAfterMissedBa,
-                                     uint8_t nMaxInflight,
-                                     const std::vector<std::string>& staChannels,
-                                     const std::vector<std::string>& apChannels,
-                                     const std::vector<uint8_t>& fixedPhyBands)
+                                     uint8_t nMaxInflight)
     : MultiLinkOperationsTestBase(
           std::string("Check MU data transmission between MLDs ") +
               (useBarAfterMissedBa == WifiUseBarAfterMissedBa::YES
@@ -1857,9 +2440,7 @@
               " MU Traffic pattern: " + std::to_string(static_cast<uint8_t>(muTrafficPattern)) +
               ", nMaxInflight=" + std::to_string(nMaxInflight) + ")",
           2,
-          staChannels,
-          apChannels,
-          fixedPhyBands),
+          baseParams),
       m_muTrafficPattern(muTrafficPattern),
       m_useBarAfterMissedBa(useBarAfterMissedBa == WifiUseBarAfterMissedBa::YES),
       m_nMaxInflight(nMaxInflight),
@@ -1869,12 +2450,15 @@
 }
 
 void
-MultiLinkMuTxTest::Transmit(uint8_t linkId,
-                            std::string context,
+MultiLinkMuTxTest::Transmit(Ptr<WifiMac> mac,
+                            uint8_t phyId,
                             WifiConstPsduMap psduMap,
                             WifiTxVector txVector,
                             double txPowerW)
 {
+    MultiLinkOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+    auto linkId = m_txPsdus.back().linkId;
+
     CtrlTriggerHeader trigger;
 
     for (const auto& [staId, psdu] : psduMap)
@@ -1976,29 +2560,20 @@
             {
                 m_waitFirstTf = false;
                 // the AP is starting the transmission of the Basic Trigger frame, so generate
-                // the configured number of packets at STAs, which are sent in TB PPDUs
-                auto band = m_apMac->GetWifiPhy(linkId)->GetPhyBand();
+                // the configured number of packets at STAs, which are sent in TB PPDUs, when
+                // transmission of the Trigger Frame ends
+                auto band = mac->GetWifiPhy(linkId)->GetPhyBand();
                 Time txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, band);
                 for (uint8_t i = 0; i < m_nStations; i++)
                 {
-                    Ptr<PacketSocketClient> client = CreateObject<PacketSocketClient>();
-                    client->SetAttribute("PacketSize", UintegerValue(450));
-                    client->SetAttribute("MaxPackets", UintegerValue(m_nPackets));
-                    client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-                    client->SetAttribute("Priority", UintegerValue(i * 4)); // 0 and 4
-                    client->SetRemote(m_sockets[i]);
-                    m_staMacs[i]->GetDevice()->GetNode()->AddApplication(client);
-                    client->SetStartTime(txDuration);  // start when TX ends
-                    client->SetStopTime(Seconds(1.0)); // stop in a second
-                    client->Initialize();
+                    m_staMacs[i]->GetDevice()->GetNode()->AddApplication(
+                        GetApplication(m_sockets[i], m_nPackets, 450, txDuration, i * 4));
                 }
             }
             break;
         default:;
         }
     }
-
-    MultiLinkOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
 }
 
 void
@@ -2167,13 +2742,6 @@
 }
 
 void
-MultiLinkMuTxTest::L7Receive(uint8_t nodeId, Ptr<const Packet> p, const Address& addr)
-{
-    NS_LOG_INFO("Packet received by NODE " << +nodeId << "\n");
-    m_rxPkts[nodeId]++;
-}
-
-void
 MultiLinkMuTxTest::DoSetup()
 {
     switch (m_muTrafficPattern)
@@ -2226,73 +2794,49 @@
         m_errorModels[m_apMac->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
         m_apMac->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
     }
-    for (std::size_t linkId = 0; linkId < m_staMacs[0]->GetNLinks(); linkId++)
+    for (std::size_t i : {0, 1})
     {
-        auto errorModel = CreateObject<ListErrorModel>();
-        m_errorModels[m_staMacs[0]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
-        m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
-
-        errorModel = CreateObject<ListErrorModel>();
-        m_errorModels[m_staMacs[1]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
-        m_staMacs[1]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+        for (const auto linkId : m_staMacs[i]->GetLinkIds())
+        {
+            auto errorModel = CreateObject<ListErrorModel>();
+            m_errorModels[m_staMacs[i]->GetFrameExchangeManager(linkId)->GetAddress()] = errorModel;
+            m_staMacs[i]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(errorModel);
+        }
     }
 }
 
 void
 MultiLinkMuTxTest::StartTraffic()
 {
-    const Time duration = Seconds(1);
-    Address destAddr;
-
-    PacketSocketHelper packetSocket;
-    packetSocket.Install(m_apMac->GetDevice()->GetNode());
-    packetSocket.Install(m_staMacs[0]->GetDevice()->GetNode());
-    packetSocket.Install(m_staMacs[1]->GetDevice()->GetNode());
-
     if (m_muTrafficPattern < WifiMuTrafficPattern::UL_MU)
     {
         // DL Traffic
         for (uint8_t i = 0; i < m_nStations; i++)
         {
-            PacketSocketAddress socket;
-            socket.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
-            socket.SetPhysicalAddress(m_staMacs[i]->GetDevice()->GetAddress());
-            socket.SetProtocol(1);
+            PacketSocketAddress sockAddr;
+            sockAddr.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
+            sockAddr.SetPhysicalAddress(m_staMacs[i]->GetDevice()->GetAddress());
+            sockAddr.SetProtocol(1);
 
             // the first client application generates three packets in order
             // to trigger the establishment of a Block Ack agreement
-            auto client1 = CreateObject<PacketSocketClient>();
-            client1->SetAttribute("PacketSize", UintegerValue(450));
-            client1->SetAttribute("MaxPackets", UintegerValue(3));
-            client1->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-            client1->SetRemote(socket);
-            m_apMac->GetDevice()->GetNode()->AddApplication(client1);
-            client1->SetStartTime(i * MilliSeconds(50));
-            client1->SetStopTime(duration);
+            m_apMac->GetDevice()->GetNode()->AddApplication(
+                GetApplication(sockAddr, 3, 450, i * MilliSeconds(50)));
 
             // the second client application generates the first half of the selected number
-            // of packets, which are sent in DL MU PPDUs.
-            auto client2 = CreateObject<PacketSocketClient>();
-            client2->SetAttribute("PacketSize", UintegerValue(450));
-            client2->SetAttribute("MaxPackets", UintegerValue(m_nPackets / 2));
-            client2->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-            client2->SetRemote(socket);
-            m_apMac->GetDevice()->GetNode()->AddApplication(client2);
-            // start after all BA agreements are established
-            client2->SetStartTime(m_nStations * MilliSeconds(50));
-            client2->SetStopTime(duration);
+            // of packets, which are sent in DL MU PPDUs, and starts after all BA agreements
+            // are established
+            m_apMac->GetDevice()->GetNode()->AddApplication(
+                GetApplication(sockAddr, m_nPackets / 2, 450, m_nStations * MilliSeconds(50)));
 
             // the third client application generates the second half of the selected number
-            // of packets, which are sent in DL MU PPDUs.
-            auto client3 = CreateObject<PacketSocketClient>();
-            client3->SetAttribute("PacketSize", UintegerValue(450));
-            client3->SetAttribute("MaxPackets", UintegerValue(m_nPackets / 2));
-            client3->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-            client3->SetRemote(socket);
-            m_apMac->GetDevice()->GetNode()->AddApplication(client3);
-            // start during transmission of first A-MPDU, if multiple links are setup
-            client3->SetStartTime(m_nStations * MilliSeconds(50) + MilliSeconds(3));
-            client3->SetStopTime(duration);
+            // of packets, which are sent in DL MU PPDUs, and starts during transmission of
+            // first A-MPDU, if multiple links are setup
+            m_apMac->GetDevice()->GetNode()->AddApplication(
+                GetApplication(sockAddr,
+                               m_nPackets / 2,
+                               450,
+                               m_nStations * MilliSeconds(50) + MilliSeconds(3)));
         }
     }
     else
@@ -2306,15 +2850,8 @@
 
             // the first client application generates three packets in order
             // to trigger the establishment of a Block Ack agreement
-            Ptr<PacketSocketClient> client1 = CreateObject<PacketSocketClient>();
-            client1->SetAttribute("PacketSize", UintegerValue(450));
-            client1->SetAttribute("MaxPackets", UintegerValue(3));
-            client1->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-            client1->SetAttribute("Priority", UintegerValue(i * 4)); // 0 and 4
-            client1->SetRemote(m_sockets[i]);
-            m_staMacs[i]->GetDevice()->GetNode()->AddApplication(client1);
-            client1->SetStartTime(i * MilliSeconds(50));
-            client1->SetStopTime(duration);
+            m_staMacs[i]->GetDevice()->GetNode()->AddApplication(
+                GetApplication(m_sockets[i], 3, 450, i * MilliSeconds(50), i * 4));
 
             // packets to be included in TB PPDUs are generated (by Transmit()) when
             // the first Basic Trigger Frame is sent by the AP
@@ -2330,26 +2867,7 @@
         });
     }
 
-    // install a server on all nodes and connect traced callback
-    for (auto nodeIt = NodeList::Begin(); nodeIt != NodeList::End(); nodeIt++)
-    {
-        PacketSocketAddress srvAddr;
-        auto device = DynamicCast<WifiNetDevice>((*nodeIt)->GetDevice(0));
-        NS_TEST_ASSERT_MSG_NE(device, nullptr, "Expected a WifiNetDevice");
-        srvAddr.SetSingleDevice(device->GetIfIndex());
-        srvAddr.SetProtocol(1);
-
-        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
-        server->SetLocal(srvAddr);
-        (*nodeIt)->AddApplication(server);
-        server->SetStartTime(Seconds(0)); // now
-        server->SetStopTime(duration);
-        server->TraceConnectWithoutContext(
-            "Rx",
-            MakeCallback(&MultiLinkMuTxTest::L7Receive, this).Bind(device->GetNode()->GetId()));
-    }
-
-    Simulator::Stop(duration);
+    Simulator::Stop(m_duration);
 }
 
 void
@@ -2441,8 +2959,8 @@
   protected:
     void DoSetup() override;
     void DoRun() override;
-    void Transmit(uint8_t linkId,
-                  std::string context,
+    void Transmit(Ptr<WifiMac> mac,
+                  uint8_t phyId,
                   WifiConstPsduMap psduMap,
                   WifiTxVector txVector,
                   double txPowerW) override;
@@ -2450,12 +2968,7 @@
   private:
     void StartTraffic() override;
 
-    /**
-     * \return the client application generating 4 packets addressed to the non-AP MLD
-     */
-    Ptr<PacketSocketClient> GetApplication() const;
-
-    PacketSocketAddress m_socket;     //!< packet socket address
+    PacketSocketAddress m_sockAddr;   //!< packet socket address
     std::size_t m_nQosDataFrames;     //!< counter for transmitted QoS data frames
     Ptr<ListErrorModel> m_errorModel; //!< error rate model to corrupt first RTS frame
     bool m_rtsCorrupted;              //!< whether the first RTS frame has been corrupted
@@ -2465,8 +2978,9 @@
     : MultiLinkOperationsTestBase(
           "Check sequence numbers after CTS timeout",
           1,
-          {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-          {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"}),
+          BaseParams{{"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                     {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                     {}}),
       m_nQosDataFrames(0),
       m_errorModel(CreateObject<ListErrorModel>()),
       m_rtsCorrupted(false)
@@ -2482,62 +2996,32 @@
     MultiLinkOperationsTestBase::DoSetup();
 
     // install post reception error model on all STAs affiliated with non-AP MLD
-    for (std::size_t linkId = 0; linkId < m_staMacs[0]->GetNLinks(); linkId++)
+    for (const auto linkId : m_staMacs[0]->GetLinkIds())
     {
         m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_errorModel);
     }
 }
 
-Ptr<PacketSocketClient>
-ReleaseSeqNoAfterCtsTimeoutTest::GetApplication() const
-{
-    const Time duration = Seconds(1);
-
-    auto client = CreateObject<PacketSocketClient>();
-    client->SetAttribute("PacketSize", UintegerValue(1000));
-    client->SetAttribute("MaxPackets", UintegerValue(4));
-    client->SetAttribute("Interval", TimeValue(MicroSeconds(0)));
-    client->SetRemote(m_socket);
-    client->SetStartTime(Seconds(0)); // now
-    client->SetStopTime(duration);
-
-    return client;
-}
-
 void
 ReleaseSeqNoAfterCtsTimeoutTest::StartTraffic()
 {
-    const Time duration = Seconds(1);
-
-    PacketSocketHelper packetSocket;
-    packetSocket.Install(m_apMac->GetDevice()->GetNode());
-    packetSocket.Install(m_staMacs[0]->GetDevice()->GetNode());
-
-    m_socket.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
-    m_socket.SetPhysicalAddress(m_staMacs[0]->GetAddress());
-    m_socket.SetProtocol(1);
+    m_sockAddr.SetSingleDevice(m_apMac->GetDevice()->GetIfIndex());
+    m_sockAddr.SetPhysicalAddress(m_staMacs[0]->GetAddress());
+    m_sockAddr.SetProtocol(1);
 
     // install client application generating 4 packets
-    m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication());
-
-    // install a server on all nodes
-    for (auto nodeIt = NodeList::Begin(); nodeIt != NodeList::End(); nodeIt++)
-    {
-        Ptr<PacketSocketServer> server = CreateObject<PacketSocketServer>();
-        server->SetLocal(m_socket);
-        (*nodeIt)->AddApplication(server);
-        server->SetStartTime(Seconds(0)); // now
-        server->SetStopTime(duration);
-    }
+    m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication(m_sockAddr, 4, 1000));
 }
 
 void
-ReleaseSeqNoAfterCtsTimeoutTest::Transmit(uint8_t linkId,
-                                          std::string context,
+ReleaseSeqNoAfterCtsTimeoutTest::Transmit(Ptr<WifiMac> mac,
+                                          uint8_t phyId,
                                           WifiConstPsduMap psduMap,
                                           WifiTxVector txVector,
                                           double txPowerW)
 {
+    MultiLinkOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+
     auto psdu = psduMap.begin()->second;
 
     if (psdu->GetHeader(0).IsRts() && !m_rtsCorrupted)
@@ -2545,7 +3029,7 @@
         m_errorModel->SetList({psdu->GetPacket()->GetUid()});
         m_rtsCorrupted = true;
         // generate other packets when the first RTS is transmitted
-        m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication());
+        m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication(m_sockAddr, 4, 1000));
     }
     else if (psdu->GetHeader(0).IsQosData())
     {
@@ -2554,17 +3038,15 @@
         if (m_nQosDataFrames == 2)
         {
             // generate other packets when the second QoS data frame is transmitted
-            m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication());
+            m_apMac->GetDevice()->GetNode()->AddApplication(GetApplication(m_sockAddr, 4, 1000));
         }
     }
-
-    MultiLinkOperationsTestBase::Transmit(linkId, context, psduMap, txVector, txPowerW);
 }
 
 void
 ReleaseSeqNoAfterCtsTimeoutTest::DoRun()
 {
-    Simulator::Stop(Seconds(1.0));
+    Simulator::Stop(m_duration);
     Simulator::Run();
 
     NS_TEST_EXPECT_MSG_EQ(m_nQosDataFrames, 3, "Unexpected number of transmitted QoS data frames");
@@ -2624,89 +3106,127 @@
 WifiMultiLinkOperationsTestSuite::WifiMultiLinkOperationsTestSuite()
     : TestSuite("wifi-mlo", UNIT)
 {
-    using ParamsTuple =
-        std::tuple<std::vector<std::string>,                 // non-AP MLD channels
-                   std::vector<std::string>,                 // AP MLD channels
-                   std::vector<std::pair<uint8_t, uint8_t>>, // (STA link ID, AP link ID) of setup
-                                                             // links
-                   std::vector<uint8_t>>; // IDs of link that cannot change PHY band
+    using ParamsTuple = std::tuple<MultiLinkOperationsTestBase::BaseParams, // base config params
+                                   std::vector<uint8_t>, // link ID of setup links
+                                   uint8_t,              // AP negotiation support
+                                   std::string,          // DL TID-to-Link Mapping
+                                   std::string>;         // UL TID-to-Link Mapping
 
     AddTestCase(new GetRnrLinkInfoTest(), TestCase::QUICK);
+    AddTestCase(new MldSwapLinksTest(), TestCase::QUICK);
 
-    for (const auto& [staChannels, apChannels, setupLinks, fixedPhyBands] :
+    for (const auto& [baseParams,
+                      setupLinks,
+                      apNegSupport,
+                      dlTidLinkMapping,
+                      ulTidLinkMapping] :
          {// matching channels: setup all links
-          ParamsTuple({"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                      {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                      {{0, 0}, {1, 1}, {2, 2}},
-                      {}),
+          ParamsTuple({{"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                       {}},
+                      {0, 1, 2},
+                      0, // AP MLD does not support TID-to-Link Mapping negotiation
+                      "0,1,2,3  0,1,2;  4,5  0,1", // default mapping used instead
+                      "0,1,2,3  1,2;    6,7  0,1"  // default mapping used instead
+                      ),
           // non-matching channels, matching PHY bands: setup all links
-          ParamsTuple({"{108, 0, BAND_5GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
-                      {"{36, 0, BAND_5GHZ, 0}", "{120, 0, BAND_5GHZ, 0}", "{5, 0, BAND_6GHZ, 0}"},
-                      {{1, 0}, {0, 1}, {2, 2}},
-                      {}),
+          ParamsTuple({{"{108, 0, BAND_5GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{120, 0, BAND_5GHZ, 0}", "{5, 0, BAND_6GHZ, 0}"},
+                       {}},
+                      {0, 1, 2},
+                      1, // AP MLD does not support distinct link sets for TIDs
+                      "0,1,2,3  0,1,2;  4,5  0,1", // default mapping used instead
+                      ""),
           // non-AP MLD switches band on some links to setup 3 links
-          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
-                      {"{36, 0, BAND_5GHZ, 0}", "{9, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                      {{2, 0}, {0, 1}, {1, 2}},
-                      {}),
+          ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{9, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {}},
+                      {0, 1, 2},
+                      3,
+                      "0,1,2,3  0;  4,5,6,7  1,2", // frames of two TIDs are generated
+                      "0,2,3  1,2;  1,4,5,6,7  0"  // frames of two TIDs are generated
+                      ),
           // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
           // that band, hence only 2 links are setup
           ParamsTuple(
-              {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
-              {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-              {{1, 0}, {2, 1}},
-              {0}),
+              {{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
+               {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+               {0}},
+              {0, 1},
+              1, // AP MLD does not support distinct link sets for TIDs
+              "0,1,2,3,4,5,6,7  0",
+              "0,1,2,3,4,5,6,7  0"),
           // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
           // that band; the second link of the non-AP MLD cannot change PHY band and there is
           // an AP operating on the same channel; hence 2 links are setup
           ParamsTuple(
-              {"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
-              {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-              {{1, 0}, {2, 1}},
-              {0, 1}),
+              {{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{8, 20, BAND_2_4GHZ, 0}"},
+               {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+               {0, 1}},
+              {0, 1},
+              3,
+              "0,1,2,3  1",
+              "0,1,2,3  1"),
           // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
           // that band; the second link of the non-AP MLD cannot change PHY band and there is
           // an AP operating on the same channel; the third link of the non-AP MLD cannot
           // change PHY band and there is an AP operating on the same band (different channel);
           // hence 2 links are setup by switching channel (not band) on the third link
-          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{60, 0, BAND_5GHZ, 0}"},
-                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                      {{1, 0}, {2, 2}},
-                      {0, 1, 2}),
+          ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}", "{60, 0, BAND_5GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {0, 1, 2}},
+                      {0, 2},
+                      3,
+                      "",
+                      ""),
           // the first link of the non-AP MLD cannot change PHY band and no AP is operating on
           // that band; the second link of the non-AP MLD cannot change PHY band and there is
           // an AP operating on the same channel; hence one link only is setup
-          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
-                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                      {{1, 0}},
-                      {0, 1}),
+          ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {0, 1}},
+                      {2},
+                      3,
+                      "",
+                      ""),
           // non-AP MLD has only two STAs and setups two links
-          ParamsTuple({"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
-                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                      {{0, 1}, {1, 0}},
-                      {}),
+          ParamsTuple({{"{2, 0, BAND_2_4GHZ, 0}", "{36, 0, BAND_5GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {}},
+                      {1, 0},
+                      3,
+                      "0,1,2,3  1",
+                      ""),
           // single link non-AP STA associates with an AP affiliated with an AP MLD
-          ParamsTuple({"{120, 0, BAND_5GHZ, 0}"},
-                      {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                      {{0, 2}},
-                      {}),
+          ParamsTuple({{"{120, 0, BAND_5GHZ, 0}"},
+                       {"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {}},
+                      {2}, // link ID of AP MLD only (non-AP STA is single link)
+                      3,
+                      "",
+                      ""),
           // a STA affiliated with a non-AP MLD associates with a single link AP
-          ParamsTuple({"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
-                      {"{120, 0, BAND_5GHZ, 0}"},
-                      {{2, 0}},
-                      {})})
+          ParamsTuple({{"{36, 0, BAND_5GHZ, 0}", "{1, 0, BAND_6GHZ, 0}", "{120, 0, BAND_5GHZ, 0}"},
+                       {"{120, 0, BAND_5GHZ, 0}"},
+                       {}},
+                      {2}, // link ID of non-AP MLD only (AP is single link)
+                      0,
+                      "0,1,2,3  0,1;  4,5,6,7  0,1", // ignored by single link AP
+                      "")})
     {
-        AddTestCase(new MultiLinkSetupTest(staChannels,
-                                           apChannels,
+        AddTestCase(new MultiLinkSetupTest(baseParams,
                                            WifiScanType::PASSIVE,
                                            setupLinks,
-                                           fixedPhyBands),
+                                           apNegSupport,
+                                           dlTidLinkMapping,
+                                           ulTidLinkMapping),
                     TestCase::QUICK);
-        AddTestCase(new MultiLinkSetupTest(staChannels,
-                                           apChannels,
+        AddTestCase(new MultiLinkSetupTest(baseParams,
                                            WifiScanType::ACTIVE,
                                            setupLinks,
-                                           fixedPhyBands),
+                                           apNegSupport,
+                                           dlTidLinkMapping,
+                                           ulTidLinkMapping),
                     TestCase::QUICK);
 
         for (const auto& trafficPattern : {WifiTrafficPattern::STA_TO_STA,
